define({"0":{y:0,u:"../Content/Part_Overview.htm",l:-1,t:"Overview of Filter SDK",i:0.00124031266765043,a:"Overview of Filter SDK This section provides an overview of the Micro Focus KeyView Filter SDK and describes how to use the  C  implementation of the API. Introducing Filter SDK Getting Started"},"1":{y:0,u:"../Content/filter_shared/filtersdk_intro/intro_filtersdk.htm",l:-1,t:"Introducing Filter SDK",i:0.00176745797259977,a:"Introducing Filter SDK This section describes the Filter SDK package. "},"2":{y:0,u:"../Content/filter_shared/filtersdk_intro/Overview.htm",l:-1,t:"Overview",i:0.00124031266765043,a:"Micro Focus KeyView Filter SDK enables you to incorporate text extraction functionality into your own applications. It extracts text and metadata from a wide variety of file formats on numerous platforms, and can automatically recognize over 1000 document types. It supports both file-based and ..."},"3":{y:0,u:"../Content/filter_shared/filtersdk_intro/Features.htm",l:-1,t:"Features",i:0.00124031266765043,a:"Document readers are threadsafe. The benefit of a threadsafe technology is that you can successfully extract text from hundreds of documents simultaneously. Documents are not queued for sequential filtering, but are actually filtered at the same time. Filter supports popular word processing, ..."},"4":{y:0,u:"../Content/Shared/_KV_Platform.htm",l:-1,t:"Platforms, Compilers, and Dependencies",i:0.00124031266765043,a:"Platforms, Compilers, and Dependencies This section lists the supported platforms, supported compilers, and software dependencies for the KeyView software."},"5":{y:0,u:"../Content/Shared/_KV_Platform_Supported_Platforms.htm",l:-1,t:"Supported Platforms",i:0.00124031266765043,a:"The C Filter SDK is supported on the following platforms. CentOS 7 x86, x64, and AArch64 IBM AIX L6.1 PowerPC 32-bit and 64-bit IBM AIX L7.1 PowerPC 32-bit and 64-bit macOS 10.13 or later on 64-bit Apple-Intel architecture macOS 11 or later on Apple M1. Microsoft Windows Server 2012 x64 Microsoft ..."},"6":{y:0,u:"../Content/Shared/_KV_Platform_Compilers.htm",l:-1,t:"Supported Compilers",i:0.00124031266765043,a:"Supported Compilers The following table lists the supported compilers for the C Filter SDK."},"7":{y:0,u:"../Content/Shared/_KV_Platform_Dependencies.htm",l:-1,t:"Software Dependencies",i:0.00159174287094999,a:"To run KeyView on Windows requires the Microsoft Visual C++ 2019 redistributables to be installed. The redistributables are provided in the vcredist folder of the KeyView SDK but you can  download the latest installers from Microsoft  to get the latest security, reliability, and performance ..."},"8":{y:0,u:"../Content/Shared/_KV_install_Windows.htm",l:-1,t:"Windows Installation",i:0.00124031266765043,a:"To install the SDK on Windows, use the following procedure. To install the SDK  Run the installation program, KeyViewProductNameSDK_VersionNumber_OS.exe, where ProductName is the name of the product, VersionNumber is the product version number, and OS is the operating system. For example: ..."},"9":{y:0,u:"../Content/Shared/_KV_install_UNIX.htm",l:-1,t:"UNIX Installation",i:0.00124031266765043,a:"To install the SDK, use one of the following procedures. To install the SDK from the graphical interface Run the installation program and follow the on-screen instructions. To install the SDK from the console Run the installation program from the console as follows: ..."},"10":{y:0,u:"../Content/filter_shared/filtersdk_intro/Package_Contents.htm",l:-1,t:"Package Contents",i:0.00124031266765043,a:"The Filter SDK installation contains: All the libraries and executables necessary for extracting text from a wide variety of formats. The  include files  that define the functions and structures used by the application to establish an interface with Filter: The Java API implemented in the package ..."},"11":{y:0,u:"../Content/Shared/_KV_License_Update.htm",l:-1,t:"License Information",i:0.0214051073720649,a:"Your license key controls whether you have the full version of the KeyView SDK, or a trial version. It also determines whether the following advanced features are enabled: Advanced character set detection with the character set detection library (kvlangdetect). Advanced document readers: Microsoft ..."},"12":{y:0,u:"../Content/filter_shared/filtersdk_intro/Directory_Structure.htm",l:-1,t:"Directory Structure",i:0.00124031266765043,a:"Directory Structure The following table describes the contents of the Filter SDK. The variable  OS is the operating system for which the SDK is installed. For example, the bin directory on a standard 32-bit Windows installation would be located at KeyviewFilterSDK\\WINDOWS\\bin."},"13":{y:0,u:"../Content/Chapter_GettingStarted.htm",l:-1,t:"Getting Started",i:0.00176745797259977,a:"Getting Started This section provides an overview of Filter SDK, and describes how to use the  C  implementation of the API."},"14":{y:0,u:"../Content/C/gettingstarted/Architectural_Overview.htm",l:-1,t:"Architectural Overview",i:0.00229460327754912,a:"Architectural Overview The general architecture of the KeyView Filter technology is the same across all supported platforms and is illustrated in the following diagram:   Each component is described in the following table."},"15":{y:0,u:"../Content/C/gettingstarted/File_Caching.htm",l:-1,t:"File Caching",i:0.00124031266765043,a:"To reduce the frequency of I/O operations, and consequently improve performance, the KeyView readers load file data into memory. The readers then read the data from the cache rather than the physical disk. You can configure the amount of memory used for file caching through the formats.ini file. ..."},"16":{y:0,u:"../Content/C/gettingstarted/Filtering.htm",l:-1,t:"Filtering",i:0.00124031266765043,a:"Filter SDK enables you to filter many different types of documents. Filtering is the process of extracting the text from a document without the application-specific markup. However, the filtering process can also include the following: Subfile extraction—this process exposes all subfiles for ..."},"17":{y:0,u:"../Content/C/gettingstarted/Sub_File_Extraction.htm",l:-1,t:"Subfile Extraction",i:0.00124031266765043,a:"To filter a file, you must first determine whether the file contains any subfiles (attachments, embedded OLE objects, and so on). A file that contains subfiles is called a  container file. Archive files (such as ZIP), mail messages with attachments (such as  Microsoft Outlook Express), mail stores ..."},"18":{y:0,u:"../Content/C/gettingstarted/Using_the_C_Language_Imp.htm",l:-1,t:"Use the C-Language Implementation of the API",i:0.00345415843686415,a:"The C-language implementation of the Filter API is divided into the following  function suites: File Extraction API Functions —Open and extract subfiles in a container file. These functions also extract metadata and file format information, and control character set conversion on extraction. The  ..."},"19":{y:0,u:"../Content/C/gettingstarted/Input_Output_Operations.htm",l:-1,t:"Input/Output Operations",i:0.00124031266765043,a:"In Filter,  the source input can be either a physical file accessed through a file path, or a filter stream created from a data source. A  filter stream in the C API implementation is a C data structure that contains pointers to I/O functions similar to their standard ANSI C counterparts. This ..."},"20":{y:0,u:"../Content/C/gettingstarted/Filtering_in_File_Mode.htm",l:-1,t:"Filtering in File Mode",i:0.00124031266765043,a:"To use the Filter  file-based I/O Load the  kvfilter library and obtain the  KV_GetFilterInterfaceEx() entry point by calling  KV_GetFilterInterfaceEx() . The filter sample program contains sample code for all platforms.  Initialize a filter session by calling  fpInit()  or  fpInitWithLicenseData() ..."},"21":{y:0,u:"../Content/C/gettingstarted/Filtering_in_Stream_Mode.htm",l:-1,t:"Filtering in Stream Mode",i:0.00146278817458847,a:"To use the Filtering  stream-based I/O Load the kvfilter library and obtain the  KV_GetFilterInterfaceEx()  entry point. The filter sample program contains sample code for all platforms.  Initialize a filter session by calling  fpInit()  or  fpInitWithLicenseData() . This function\u0027s return value, ..."},"22":{y:0,u:"../Content/C/gettingstarted/Multi_Threaded_Filtering.htm",l:-1,t:"Multithreaded Filtering",i:0.00124031266765043,a:"To make sure that multithreaded filter processes are thread-safe, each context pointer created using  fpInit()  or  fpInitWithLicenseData()  should only be used by a single thread. This applies to in-process and out-of-process API calls. Creating a context pointer for every thread does not affect ..."},"23":{y:0,u:"../Content/C/gettingstarted/The_Filter_Process_Model.htm",l:-1,t:"The Filter Process Model",i:0.015593069020095,a:"By default, Filter runs independently from the calling application process. This is called out-of-process filtering. Out-of-process filtering protects the stability of the calling application in the rare case when a malformed document causes Filter to fail. You can configure Filter  to run in the ..."},"24":{y:0,u:"../Content/C/gettingstarted/Persist_the_Child_Proces.htm",l:-1,t:"Persist the Child Process",i:0.00124031266765043,a:"By default, in out-of-process filtering, the parent process maintains a persistent connection with the child server after each file is filtered. When the connection is preserved in this way, subsequent filtering requests are processed more quickly because the server is already prepared to receive ..."},"25":{y:0,u:"../Content/C/gettingstarted/Run_Filter_In_Process.htm",l:-1,t:"Run Filter In Process",i:0.00139734587265942,a:"By default, Filter runs out of process. However, you can enable in-process filtering through the API or in the formats.ini file. If the type of process is not specified in the formats.ini or in the API, Filter is run out of process. If the type of process is specified in the formats.ini and in the ..."},"26":{y:0,u:"../Content/C/gettingstarted/Run_File_Extraction_Func.htm",l:-1,t:"Run File Extraction Functions Out of Process",i:0.00176745797259977,a:"Run File  Extraction Functions Out of  Process The out-of-process setting specified in the call to  fpInit()  or  fpInitWithLicenseData()  or in the formats.ini file is automatically propagated to the File Extraction API in the call to  KVGetExtractInterface(). In KVGetExtractInterface(), you pass a ..."},"27":{y:0,u:"../Content/C/gettingstarted/Out_of_Process_Logging.htm",l:-1,t:"Out-of-Process Logging",i:0.00215710933238448,a:"Logging is available for out-of-process filtering. The kvoop server can now create a log file that captures information on the files being processed, storing one entry per process. The generated log file is called  xxxx_kvoop.log, where  xxxx is a unique number identifying the process.  In the rare ..."},"28":{y:0,u:"../Content/C/gettingstarted/Run_File_Detection_In_or.htm",l:-1,t:"Run File Detection In or Out of Process",i:0.011056287191936,a:"By default, detection runs in out-of-process mode. However, you can enable in-process detection through the API or in the formats.ini file. If the type of process is not specified in the formats.ini or in the API,  detection runs in out-of-process mode. If the type of process is specified in the ..."},"29":{y:0,u:"../Content/filter_shared/Use_Streaming_Mode.htm",l:-1,t:"Stream Data to Filter",i:0.00988561828182787,a:"By default, when you run Filter out-of-process,  and pass file streams to the API (instead of file names),  Filter uses temporary files during communication.   When running out-of-process, you can configure KeyView to stream the file data while it processes it, rather than creating temporary files. ..."},"30":{y:0,u:"../Content/Part_UseSDK.htm",l:-1,t:"Use Filter SDK",i:0.00124031266765043,a:"Use Filter SDK This section explains how to perform some basic tasks by using the File Extraction and Filter APIs, and describes the sample programs. Use the File Extraction API Use the Filter API Sample Programs"},"31":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c.htm",l:-1,t:"Use the File Extraction API",i:0.00287007652731342,a:"Use the File Extraction API This section describes how to extract subfiles from a container file by using the File Extraction API. "},"32":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Introduction.htm",l:-1,t:"Introduction",i:0.00124031266765043,a:"To  filter  a file, you must first determine whether the file contains any subfiles (attachments, embedded OLE objects, and so on). A file that contains subfiles is called a  container file. A container file has a main file (parent) and subfiles (children) embedded in the main file.  The following ..."},"33":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_Sub_Files.htm",l:-1,t:"Extract Subfiles",i:0.00187288703358964,a:"To  filter  all files in a container file, you must open the container and extract its subfiles by using the File Extraction API. The extraction process is done repeatedly until all subfiles are extracted and exposed for  filtering . After a subfile is extracted, you can call  Filter  API functions ..."},"34":{y:0,u:"../Content/_KV_xtract_sanitize_paths.htm",l:-1,t:"Sanitize Absolute Paths",i:0.00250611191278725,a:"When you extract a subfile from a container and write it to disk, you specify an extract directory  and a path to extract the file to. To set the path, you might use the path in the container file that you are extracting from, as returned  from the function  fpGetSubFileInfo() .  However, if the ..."},"35":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_SubFileInputStream.htm",l:-1,t:"Access a Subfile without Extracting the Entire File",i:0.00124031266765043,a:"Some operations do not require all of the data contained within a subfile. For example, format detection can often be performed using only the beginning and end of a file, without needing to extract the entire file to disk or memory. When filtering, you might process part of a file before deciding ..."},"36":{y:0,u:"../Content/Shared/_KV_xtract_Extract_Images.htm",l:-1,t:"Extract Images",i:0.00200556650971389,a:"You can use the File Extraction API  to extract images within a file. If you use this feature, images within the file  behave in the same way as any other subfile. Extracted images  have the name image[X].[Y], where [X] is an integer, and [Y] is the extension. The format of the image is the same as ..."},"37":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Recreate_a_Files_Hierarchy.htm",l:-1,t:"Recreate a File’s Hierarchy",i:0.0040112989467365,a:"When you extract a container file, any relationships between the subfiles in the container are not maintained. However, the File Extraction interface provides information that enables you to recreate the hierarchy. You can use the  hierarchy to create a directory structure in a file system, or to ..."},"38":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_Mail_Metadata.htm",l:-1,t:"Extract Mail Metadata",i:0.0125906100782408,a:"You can extract metadata, such as subject, sender, and recipient, from subfiles of mail formats, by calling the  fpGetSubFileMetaData()  function. You can extract a predefined set of common metadata fields, a list of metadata fields by their names or MAPI properties, or, for some subfile types, all ..."},"39":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_Outlook_Files.htm",l:-1,t:"Extract Subfiles from Outlook Files",i:0.00124031266765043,a:"Extract  Subfiles from Outlook Files When you extract an Outlook file (MSG) to disk, the message text and header information (To, From, Sent, and so on) is extracted to a text file. (If you do not want the header information to appear in the text file, see  Exclude Metadata from the Extracted Text ..."},"40":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_OutlookExpress.htm",l:-1,t:"Extract Subfiles from Outlook Express Files",i:0.00124031266765043,a:"Extract Subfiles from Outlook  Express Files When you extract an Outlook Express (EML) file to disk, the message text and header information (To, From, Sent, and so on) is extracted to a text file. (If you do not want the header information to appear in the text file, see  Exclude Metadata from the ..."},"41":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_MailboxFiles.htm",l:-1,t:"Extract Subfiles from Mailbox Files",i:0.00124031266765043,a:"Extract  Subfiles from Mailbox Files A Mailbox (MBX) file is a collection of individual emails compiled with RFC 822 and RFC 2045 - 2049 (MIME), and divided by message separators. There are many mail applications that export to an MBX format, such as Eudora Email and Mozilla Thunderbird.  When an ..."},"42":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_OutlookPersonalFolder.htm",l:-1,t:"Extract Subfiles from Outlook Personal Folders Files",i:0.00124031266765043,a:"Extract  Subfiles from Outlook Personal Folders Files KeyView can extract Outlook items such as messages, appointments, contacts, tasks, notes, and journal entries from a PST file. When a PST file is extracted to disk, the text and header information (To, From, Sent, and so on) from each Outlook ..."},"43":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_LotusDominoXML.htm",l:-1,t:"Extract Subfiles from Lotus Domino XML Language Files",i:0.00124031266765043,a:"Extract  Subfiles from Lotus Domino XML Language Files When you extract a Lotus Domino XML Language (.DXL) file, the message text and header information (To, From, Sent, and so on) is extracted to a text file.  To prevent header information from being extracted, see  Exclude Metadata from the ..."},"44":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_LotusNotes_DB.htm",l:-1,t:"Extract Subfiles from Lotus Notes Database Files",i:0.00124031266765043,a:"Extract  Subfiles from Lotus Notes Database Files A Lotus Notes database is a single file that contains multiple documents called notes. Notes include design notes (such as forms, views, folders, navigators, outlines, pages, framesets, agents, and resources), data document notes, profile document ..."},"45":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_PDF_Files.htm",l:-1,t:"Extract Subfiles from PDF Files",i:0.00229460327754912,a:"Extract  Subfiles from PDF Files KeyView can extract document-level and page-level attachments from a PDF document. Document-level attachments are added by using the Attach A File tool, and can include links to or from the parent document or to other file attachments. Page-level attachments are ..."},"46":{y:0,u:"../Content/Shared/_KV_PDF_ImprovePerformanceWithSmallImages.htm",l:-1,t:"Improve Performance for PDFs with Many Small Images",i:0.00124031266765043,a:"To improve performance when processing  PDF files that contain many small images, you can choose to ignore images unless they exceed a minimum width and/or height. If an image is smaller than the minimum width or height, KeyView does not extract the image.  For example, to ignore images that are ..."},"47":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_Embedded_OLE_Objects.htm",l:-1,t:"Extract Embedded OLE Objects",i:0.00124031266765043,a:"The File Extraction API can extract embedded  OLE objects from the following types of documents: Lotus Notes (DXL) Microsoft Excel Microsoft Word Microsoft PowerPoint Microsoft Outlook Microsoft Visio Microsoft Project OASIS Open Document Rich Text Format (RTF) When an embedded OLE object is ..."},"48":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Extract_SubFiles_ZIPFiles.htm",l:-1,t:"Extract Subfiles from ZIP Files",i:0.00124031266765043,a:"You can extract ZIP files that are not password-protected by using the general method (see  Extract Subfiles ). However, some ZIP files use password protection, in which case you must use a different method to enter the required credentials.  See  Password Protected Files  for more information."},"49":{y:0,u:"../Content/kv_xtract_api_c/_KV_xtract_c_Default_Filenames_Extracted_Subfiles.htm",l:-1,t:"Default File Names for Extracted Subfiles",i:0.00168808046415008,a:"Default File Names for  Extracted Subfiles When you do not specify a file name in the call to   fpExtractSubFile() , in some cases a default file name is applied to the extracted subfile. Default File Name for Mail Formats To avoid naming conflicts and problems with long file names, KeyView applies ..."},"50":{y:0,u:"../Content/Chapter_UseFilterAPI.htm",l:-1,t:"Use the Filter API",i:0.0020793585698894,a:"Use the Filter API This section describes how to perform some basic filtering tasks by using the Filter API."},"51":{y:0,u:"../Content/C/filter_api/Generate_an_Error_Log.htm",l:-1,t:"Generate an Error Log",i:0.0144953423019751,a:"You can monitor and debug filtering operations by enabling a detailed error log. This enables you to see errors that are generated at run time, and to track problem files in stream or file mode. Error logs are not generated when in-process filtering is enabled. The error log might include the ..."},"52":{y:0,u:"../Content/C/filter_api/Enable_Disable_Error_Logging.htm",l:-1,t:"Enable or Disable Error Logging",i:0.0129736041961317,a:"Enable or Disable Error  Logging You can enable or disable error logging by using either the API or environment variables. By default, a file called kvoop.log is created in the system temporary directory; however, you can change the path and file name of this file (see  Change the Path and File Name ..."},"53":{y:0,u:"../Content/C/filter_api/Change_Path_Log.htm",l:-1,t:"Change the Path and File Name of the Log File",i:0.00575771085512093,a:"You can change the default path and file name of the log file. The default is C:\\temp\\kvoop.log on Windows and /tmp/kvoop.log on UNIX.  To change the path and file name of the log file, add the following to the formats.ini file: [kvooplog]\nKvoopLogName=filepath"},"54":{y:0,u:"../Content/C/filter_api/Report_Memory_Errors.htm",l:-1,t:"Report Memory Errors",i:0.0129736041961317,a:"You can report memory leaks and  memory overwrites in the log file by enabling the  memory trace system, either by using the API or environment variables. If the memory trace system is enabled, the extended error codes for memory leaks and memory overwrites (26 and 27, respectively) are reported in ..."},"55":{y:0,u:"../Content/C/filter_api/Specify_a_Memory_Guard.htm",l:-1,t:"Specify a Memory Guard",i:0.00575771085512093,a:"To report memory overwrites in the log file, you must set a  memory guard that protects against memory overwrites. Normally, this is set in the range of 100-200 bytes. For example, if a memory guard of 100 is set and 20 bytes of memory are specified, a total of 120 bytes of memory are allocated. The ..."},"56":{y:0,u:"../Content/C/filter_api/Report_the_Filename_in_S.htm",l:-1,t:"Report the File Name in Stream Mode",i:0.00392288351390963,a:"When you run Filter in file mode, the file name is always reported in the log file. To report the file name in stream mode, you must extract it through the API.  To add the input file name to the log, call the  fpFilterConfig()  function with the following arguments: For example: ..."},"57":{y:0,u:"../Content/C/filter_api/Report_Extended_Error_Co.htm",l:-1,t:"Report Extended Error Codes",i:0.00300059646683718,a:"Report Extended  Error Codes When a  general error ( KVERR_General) is generated during out-of-process filtering, extended error codes can also be generated and reported in the error log. The extended error codes provide more information about the error, and are defined in  KVErrorCodeEx  in ..."},"58":{y:0,u:"../Content/C/filter_api/Specify_the_Maximum_Size.htm",l:-1,t:"Specify the Maximum Size of the Log File",i:0.00300059646683718,a:"You can specify the maximum size of the log file. When this size is reached and new entries are logged, either the first entry in the file is overwritten or the new entries are not reported.  To configure the maximum log size and whether old entries are overwritten, add the following section to the ..."},"59":{y:0,u:"../Content/C/filter_api/Extract_Metadata.htm",l:-1,t:"Extract Metadata",i:0.00271520913503278,a:"Extract  Metadata When a file format supports metadata, KeyView can extract and process that information. Metadata includes document information fields such as title, author, creation date, and file size. Depending on the file\u0027s format, metadata is referred to in a number of ways: for example, ..."},"60":{y:0,u:"../Content/C/filter_api/Extract_Metadata_for_Fil.htm",l:-1,t:"Extract Metadata for File Filtering",i:0.00124031266765043,a:"Extract Metadata for  File Filtering To extract metadata for file filtering Call  fpFilterFile() .  Declare a pointer to the  KVSummaryInfoEx  structure. Call  fpGetOLESummaryInfoFile()  to extract the metadata.  Call  fpFreeOLESummaryInfo()  to free the memory allocated for metadata extraction."},"61":{y:0,u:"../Content/C/filter_api/Extract_Metadata_for_Str.htm",l:-1,t:"Extract Metadata for Stream Filtering",i:0.00124031266765043,a:"Extract Metadata for  Stream Filtering To extract metadata for stream filtering Call  fpOpenStream()  or  fpOpenStreamEx2()  to open a stream.  Call  fpFilterStream()  to filter the stream. Call  fpCloseStream()  to close the input stream. Declare a pointer to the  KVSummaryInfoEx  structure.  Call  ..."},"62":{y:0,u:"../Content/C/filter_api/Example.htm",l:-1,t:"Example",i:0.00124031266765043,a:"Below is an example of a call to  fpGetOLESummaryInfo(): {\n  KVSummaryInfoEx    si;\n  memset( \u0026si, 0, sizeof(si) );\n  if ( KVERR_Success != (*pInterface-\u003efpGetOLESummaryInfo)( pKVFilter, pInput, \u0026si ) )\n  {\n      fprintf( fpOut, \"Error obtaining summary information\\n\" );\n      return;\n  }\n  if ( ..."},"63":{y:0,u:"../Content/C/filter_api/Convert_Character_Sets.htm",l:-1,t:"Convert Character Sets",i:0.00226913916218856,a:"Filter can convert the character set of a document to an arbitrary character set specified in the API, or to the character set of the operating system on which the output text is viewed. For this conversion to occur, a source character set must be identified. The source character set can either be ..."},"64":{y:0,u:"../Content/C/filter_api/Determine_the_CharacterSet.htm",l:-1,t:"Determine the Character Set of the Output Text",i:0.00124031266765043,a:"Determine the  Character Set of the Output Text To determine the output character set of a filtered document, Filter considers the following: Whether the document reader can determine the character set of the file format. If the document reader cannot determine the character set information for the ..."},"65":{y:0,u:"../Content/C/filter_api/Set_CharSet_Filtering.htm",l:-1,t:"Set the Character Set During Filtering",i:0.00124031266765043,a:"Set the Character  Set During Filtering You can convert the character set of a file at the time the file is filtered. To specify the source character set of a file, after calling  fpInit()  or  fpInitWithLicenseData() , call  fpSetSrcCharSet() , and set the  eCharSet argument to any value in the ..."},"66":{y:0,u:"../Content/C/filter_api/Set_CharSet_Extraction.htm",l:-1,t:"Set the Character Set During Subfile Extraction",i:0.00124031266765043,a:"Set the Character Set During  Subfile Extraction You can convert the character set of a subfile at the time the subfile is extracted from the container and before it is filtered. This is most often used to set the character set of a mail message\u0027s body text. See  Filter PDF Files  for more ..."},"67":{y:0,u:"../Content/C/filter_api/Prevent_the_Default_Conv.htm",l:-1,t:"Customize Character Set Detection and Conversion",i:0.011056287191936,a:"KeyView attempts to detect the character set of an input file by default. Some character sets (including ANSI, UTF-8, and UTF-16) can be detected by core KeyView functionality but others can only be detected if your license includes advanced character set detection. If your license includes advanced ..."},"68":{y:0,u:"../Content/C/filter_api/Extract_Deleted_Text_Mar.htm",l:-1,t:"Extract Deleted Text Marked by Tracked Changes",i:0.00216259971472288,a:"The revision tracking feature in applications—such as Microsoft Word\u0027s  Track Changes—marks changes to a document (typically, strikethrough for deleted text and underline for inserted text) and tracks each change by reviewer name and date.  If revision tracking was enabled when text was deleted from ..."},"69":{y:0,u:"../Content/C/filter_api/Filter_PDF_Files.htm",l:-1,t:"Filter PDF Files",i:0.00268974501967223,a:"Filter PDF Files Filter has special configuration options that allow greater control over the conversion of Adobe Acrobat PDF files."},"70":{y:0,u:"../Content/filter_shared/pdf2sr.htm",l:-1,t:"Use the pdf2sr Reader",i:0.00231815751530723,a:"The pdf2sr reader is an alternative that can be used instead of pdfsr for filtering PDF files. It uses a different parsing technology and may yield better results for some files. The pdf2sr reader has the following features: supports standard and custom metadata (non-XMP) supports basic text ..."},"71":{y:0,u:"../Content/C/filter_api/Filter_PDF_LogicalOrder.htm",l:-1,t:"Filter PDF Files to a Logical Reading Order",i:0.00209271558999324,a:"The PDF format is primarily designed for presentation and printing of brochures, magazines, forms, reports, and other materials with complex visual designs. Most PDF files do not contain the logical structure of the original document—the correct reading order, for example, and the presence and ..."},"72":{y:0,u:"../Content/C/filter_api/Rotated_Text.htm",l:-1,t:"Rotated Text",i:0.00124031266765043,a:"When a PDF that contains rotated text is filtered, the rotated text is extracted after the text at the end of the PDF page on which the rotated text appears. If the PDF is filtered with logical order enabled, and the amount of rotated text on a page surpasses a predefined threshold,  the page is ..."},"73":{y:0,u:"../Content/C/filter_api/Extract_Custom_Metadata_PDF.htm",l:-1,t:"Extract Custom Metadata from PDF Files",i:0.00200556650971389,a:"Extract Custom Metadata  from PDF Files You can extract custom metadata from PDF files either by specifying individual metadata tag names, or by extracting all custom metadata at once. Extract Custom Metadata by Tag To extract custom metadata by metadata tag, add the custom metadata names to the  ..."},"74":{y:0,u:"../Content/C/filter_api/Filter_Tagged_PDF_Content.htm",l:-1,t:"Filter Tagged PDF Content",i:0.00200556650971389,a:"A tagged PDF contains an additional layer of text for visually impaired readers. This text is used in text-to-speech features in various PDF viewing programs. You can enable filtering of tagged PDF text in the API. Filtering the extra layer of tagged content might result in duplicate text in the ..."},"75":{y:0,u:"../Content/C/filter_api/Skip_Embedded_Fonts.htm",l:-1,t:"Skip Embedded Fonts",i:0.00124031266765043,a:"Text in PDF files sometimes contains embedded fonts. If you experience difficulties filtering embedded fonts, there are options in the API, the formats.ini file, and the filter sample program that enable you to skip this type of text. If you skip embedded fonts, none of the content that contains ..."},"76":{y:0,u:"../Content/C/filter_api/Control_Hyphenation.htm",l:-1,t:"Control Hyphenation",i:0.00124031266765043,a:"There are two types of hyphens in a PDF document:  A soft hyphen is added to a word by a word processor to divide the word across two lines. This is a discretionary hyphen and is used to ensure proper text flow in justified text. A hard hyphen is intentionally added to a word regardless of the ..."},"77":{y:0,u:"../Content/C/filter_api/Filter_Portfolio_PDF.htm",l:-1,t:"Filter Portfolio PDF Files",i:0.00124031266765043,a:"Filter Portfolio PDF Files Portfolio PDF files contain subfiles and an ActionScript interface for navigating between them. You can use the extraction API to extract the subfiles. See  Extract Subfiles from PDF Files ."},"78":{y:0,u:"../Content/Shared/_KV_Table_Detection_PDF.htm",l:-1,t:"Table Detection for PDF Files",i:0.00200556650971389,a:"PDF files often contain data presented in a tabular form. However, there is no information about the table stored within the PDF itself – the text is simply placed in  an arrangement that looks like a table to the human eye. When this data is filtered, it can be very difficult to reconstruct the ..."},"79":{y:0,u:"../Content/C/filter_api/Filter_RMS_PDF_Files.htm",l:-1,t:"Filter RMS Protected PDF Files",i:0.00124031266765043,a:"RMS-protected PDF files have two parts. The first is an unencrypted \"outer\" PDF, which contains standard text stating that the document is protected. The second is an encrypted \"inner\" PDF, which is attached to the outer PDF and contains the actual content. To filter both parts separately, filter ..."},"80":{y:0,u:"../Content/C/filter_api/Filter_Spreadsheet_Files.htm",l:-1,t:"Filter Spreadsheet Files",i:0.00124031266765043,a:"Filter Spreadsheet Files Filter has special configuration options that enable greater control over the conversion of spreadsheet files."},"81":{y:0,u:"../Content/C/filter_api/Filter_Worksheet_Names.htm",l:-1,t:"Filter Worksheet Names",i:0.00124031266765043,a:"Filter  Worksheet Names Normally, Filter does not extract worksheet names from a spreadsheet because it is assumed that the text should not be exposed. To extract worksheet names, add the following lines to the  formats.ini file: [Options]\ngetsheetnames=1"},"82":{y:0,u:"../Content/C/filter_api/Filter_Hidden_Text_in_Mi.htm",l:-1,t:"Filter Hidden Text in Microsoft Excel Files",i:0.0026091591897157,a:"Filter  Hidden Text in Microsoft Excel Files Normally, Filter does not filter hidden text from a Microsoft Excel spreadsheet because it is assumed that the text should not be exposed. To extract text from hidden rows, columns, and sheets from Excel spreadsheets, add the following lines to the ..."},"83":{y:0,u:"../Content/C/filter_api/Specify_Date_and_Time_Fo.htm",l:-1,t:"Specify Date and Time Format on UNIX Systems",i:0.00124031266765043,a:"In Microsoft Excel you can choose to format dates and times according to the system locale.  On Windows, KeyView uses the system locale settings to determine how these dates and times should be formatted.  In other operating systems, KeyView uses the U.S. short date format (mm/dd/yyyy).  You can ..."},"84":{y:0,u:"../Content/C/filter_api/large_numbers_excel.htm",l:-1,t:"Filter Very Large Numbers in Spreadsheet Cells to Precision Numbers",i:0.00124031266765043,a:"By default, numbers are extracted in the format specified by the Excel file (for example, General, Currency and Date). Spreadsheets might contain cells that have very large numbers in them. Excel displays the numbers in a scientific notation that rounds or truncates the numbers.  To extract numbers ..."},"85":{y:0,u:"../Content/filter_shared/Extract_Excel_Formulas.htm",l:-1,t:"Extract Microsoft Excel Formulas",i:0.0026091591897157,a:"When you filter a Microsoft Excel spreadsheet, KeyView extracts the value of each cell. The value of a cell might be calculated from a formula, but the formula is not included in the output unless you configure KeyView to include it. You can extract the cell value, the formula, or both. For example, ..."},"86":{y:0,u:"../Content/Shared/_KV_Standardize_Cell_Formats.htm",l:-1,t:"Standardize Cell Formats",i:0.00200556650971389,a:"In Microsoft Excel you can format cell values. For example, the date \"15/09/2021\" could be formatted as \"15 September 2021\" or \"2021-09-15\". By default, KeyView extracts cell values with formatting, as they would appear in Excel. If you prefer, you can configure KeyView to standardize cell values. ..."},"87":{y:0,u:"../Content/filter_shared/Tab_Delimited_Output.htm",l:-1,t:"Tab Delimited Output for Spreadsheets and Embedded Tables",i:0.00200556650971389,a:"You can use KeyView to convert spreadsheets, embedded tables in Word Processing documents (for example, Microsoft Word documents), and tables detected by Optical Character Recognition (OCR), to tab-delimited form. In this format, KeyView inserts a tab character between each cell, and a line break ..."},"88":{y:0,u:"../Content/filter_shared/Presentation_LogicalOrder.htm",l:-1,t:"Filter Presentation Files to a Logical Reading Order",i:0.00200556650971389,a:"With some file formats, for example Microsoft PowerPoint presentations, the order of the text inside the file has no relation to the layout of the text on the page or screen. Recently modified text might appear at the end of a file, even though that text belongs at the beginning of the document. You ..."},"89":{y:0,u:"../Content/C/filter_api/Filter_XML_Files.htm",l:-1,t:"Filter XML Files",i:0.00216259971472288,a:"KeyView can detect many types of XML file, including: Generic XML Microsoft Office 2003 XML (Word, Excel, and Visio) StarOffice/OpenOffice XML (text document, presentation, and spreadsheet) When you filter XML, you can tell KeyView which elements to treat as content and metadata, or to treat the ..."},"90":{y:0,u:"../Content/C/filter_api/Configure_Element_Extrac.htm",l:-1,t:"Configure Element Extraction for XML Documents",i:0.00445108286068891,a:"When filtering XML files, you can specify which elements and attributes to extract according to the file\u0027s format ID or root element. This is useful when you want to extract only relevant text elements, such as abstracts from reports, or a list of authors from an anthology.  A  root element is an ..."},"91":{y:0,u:"../Content/filter_shared/custom_headerfooter.htm",l:-1,t:"Configure Headers and Footers",i:0.00124031266765043,a:"You can configure custom header and footer tags for word processing and spreadsheet documents  by editing the formats.ini file. To configure headers and footers Open the formats.ini file. In the [Options] section, add the following items: ..."},"92":{y:0,u:"../Content/C/filter_api/Filter_Hidden_Data.htm",l:-1,t:"Filter Hidden Data",i:0.00234925121988795,a:"Filter Hidden Data Some documents contain hidden information, which is not filtered by default. Depending on the type of hidden data that you want to filter and the type of document that you are filtering, you can either use the API or set parameters in the formats.ini file."},"93":{y:0,u:"../Content/C/filter_api/Hidden_Data_Excel.htm",l:-1,t:"Hidden Data in Microsoft Excel Documents",i:0.00644132071866399,a:"There are several types of hidden data in Microsoft Excel documents, each of which has a corresponding flag in the  KV_CONFIG_Arg  structure, which you can toggle to determine whether the hidden data is shown. The following table lists each data type, its default behavior, and its corresponding ..."},"94":{y:0,u:"../Content/C/filter_api/Hidden_Data_HTML.htm",l:-1,t:"Hidden Data in HTML Documents",i:0.00124031266765043,a:"KeyView can filter comments from HTML documents. To enable comment filtering, you must set a flag in the formats.ini file. To enable filtering of comments from HTML files Open the formats.ini file in a text editor. Under [Options], set the following flag. GetHTMLHiddenInfo= 1"},"95":{y:0,u:"../Content/Shared/_KV_No_Phonetic_Guides.htm",l:-1,t:"Exclude Japanese Guide Text",i:0.00200556650971389,a:"This option prevents output of Japanese phonetic guide text when Microsoft Excel (.xlsx) files are processed. To prevent output of Japanese phonetic guide text In the C API, call the function fpFilterConfig and set the flag KVFLT_NOPHONETICGUIDES. In  formats.ini, set the following parameter.  (This ..."},"96":{y:0,u:"../Content/Shared/_KV_Code_Identification.htm",l:-1,t:"Source Code Identification",i:0.00200556650971389,a:"When KeyView auto-detects a file that contains source code, it can attempt to identify the programming language that it is written in. When you do not enable source code identification, files containing source code may be identified as ASCII text files, causing the application to treat them in the ..."},"97":{y:0,u:"../Content/filter_shared/OCR.htm",l:-1,t:"Optical Character Recognition",i:0.00720378547385149,a:"When processing raster image files, KeyView can perform Optical Character Recognition (OCR) to attempt to filter text that might be visible in the image. If text is detected to form part of a table, it will be filtered in the same way as tables in Word Processing documents. KeyView performs OCR only ..."},"98":{y:0,u:"../Content/kv_RMS/_KV_RMS_ConfigureProxyForRMS.htm",l:-1,t:"Configure the Proxy for RMS",i:0.00124031266765043,a:"When KeyView needs to access contents that are protected by the Microsoft Rights Management System (RMS), it must make HTTP requests. By default, KeyView uses the system proxy settings for these requests.  To use different proxy settings, you can configure them  in the [RMS] section of the ..."},"99":{y:0,u:"../Content/filter_shared/DocumentRestrictions.htm",l:-1,t:"Document Restrictions",i:0.00281083599060794,a:"Some applications, and corresponding file formats, allow users to restrict the ways in which a document can be used. For example, you might be able to read a document but additional credentials (such as a password) could be required to modify the document content, add comments, or print the ..."},"100":{y:0,u:"../Content/C/filter_api/Run_KeyView_Reduced_Privileges.htm",l:-1,t:"Run KeyView with Reduced Privileges",i:0.00279851728047461,a:"KeyView, by default, runs as the same user and has the same privileges as the application that calls it. When you run KeyView in-process this cannot be changed. When you run KeyView out-of-process, you can choose to run KVOOP (the out-of-process server) as a different user with reduced privileges. ..."},"101":{y:0,u:"../Content/C/filter_api/Unexpected_ZIP_Detection.htm",l:-1,t:"Unexpected ZIP Detection",i:0.00200556650971389,a:"Concatenating a ZIP file onto another file, such as a JPEG, is a well-known method for attempting to hide files from inspection. Users can zip up their sensitive files, then concatenate them on to the other file by using something like the Windows copy command-line tool. The result is a file that ..."},"102":{y:0,u:"../Content/Chapter_Samples.htm",l:-1,t:"Sample Programs",i:0.00236107327556766,a:"Sample Programs This section describes the sample programs provided with Filter SDK."},"103":{y:0,u:"../Content/C/samples/Introduction.htm",l:-1,t:"Introduction",i:0.00124031266765043,a:"The C sample programs demonstrate how to use the C implementation of the Filter API. The sample code is intended to provide a starting point for your own applications or to be used for reference purposes. The following C sample programs are provided: tstxtract filter The source code and makefile ( ..."},"104":{y:0,u:"../Content/Shared/_KV_xtract_samples_c.htm",l:-1,t:"tstxtract",i:0.00285294612002258,a:"The tstxtract sample program demonstrates the File Extraction API. It opens a file, extracts subfiles from the file, and repeats the extraction process until all subfiles are extracted. It also demonstrates how to extract the default set of metadata and pass integer or string names to extract ..."},"105":{y:0,u:"../Content/C/samples/filter.htm",l:-1,t:"filter",i:0.00295578537047649,a:"The  filter  sample program demonstrates the advanced functionality of the Filter API. It is composed of the following files: filter.c—command line interface filtersupport.c—contains core functionality, such as file filtering, stream filtering, metadata extraction, and format detection. ..."},"106":{y:0,u:"../Content/Part_C_API_Ref.htm",l:-1,t:"C API Reference",i:0.00124031266765043,a:"C API Reference This section provides detailed reference information for the C-language implementation of the File Extraction and Filter APIs. File Extraction API Functions File Extraction API Structures Filter API Functions Filter API Structures Enumerated Types"},"107":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_functions.htm",l:-1,t:"File Extraction API Functions",i:0.00394888089237844,a:"This section describes the functions in the File Extraction API. The File Extraction functions open a container file, and extract the container’s subfiles so that the subfiles are exposed and available for \n\t\t filtering .\n\t\tSubfiles can be files within a Zip archive, messages in a mail store, ..."},"108":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_KVGetExtractInterface.htm",l:-1,t:"KVGetExtractInterface()",i:0.00342259699926507,a:"This function is the entry point to obtain the file extraction functions.  It supplies pointers to the file extraction functions, and in the case of out-of-process mode starts the kvoop.exe server and initializes out-of-process extraction services.  When  KVGetExtractInterface() is called, it ..."},"109":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpCloseFile.htm",l:-1,t:"fpCloseFile()",i:0.00859863811549006,a:"This function frees the memory allocated by  fpOpenFile()  and closes the file. Syntax int (pascal *fpCloseFile) (void *pFile); Arguments Returns If the file is closed, the return value is KVERR_Success.  If the file is not closed, the return value is an error code. Example ..."},"110":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpCloseSubFile.htm",l:-1,t:"fpCloseSubFile()",i:0.0024235865762971,a:"fpCloseSubFile() Closes a stream opened by  fpOpenSubFile() . Syntax int (pascal *fpCloseSubFile) (\n        KVInputStream *stream); Arguments Returns If the subfile is closed, the return value is KVERR_Success If the subfile is not closed, the return value is an error code."},"111":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpExtractSubFile.htm",l:-1,t:"fpExtractSubFile()",i:0.012815049934136,a:"This function extracts a subfile from a container file to a user-defined path or output stream. This call returns file format information when file is extracted to a path. Syntax int (pascal *fpExtractSubFile)  (\n\t            void                          *pFile, \n\t\t    ..."},"112":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpFreeStruct.htm",l:-1,t:"fpFreeStruct()",i:0.00660545400401947,a:"This function frees the memory allocated by fpGetMainFileInfo(), fpGetSubFileInfo(), fpGetSubFileMetadata(), and fpExtractSubFile(). Syntax int (pascal *fpFreeStruct) (\n    void      *pFile, \n    void      *obj);  Arguments Returns If the allocated memory is freed, the return value is KVERR_Success. ..."},"113":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpGetExtractInfo.htm",l:-1,t:"fpGetExtractInfo()",i:0.00124031266765043,a:"This function returns information about a stream opened by  fpOpenSubFile() . Syntax int (pascal *fpGetExtractInfo) (\n       KVInputStream *stream,\n       KVSubFileExtractInfo *extractInfo);\n Arguments Returns If an issue occurs when obtaining the extraction information, the return value is an error ..."},"114":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpGetExtractStatus.htm",l:-1,t:"fpGetExtractStatus()",i:0.0013457417286403,a:"This function returns the status of an input stream opened by  fpOpenSubFile() . Syntax int (pascal *fpGetExtractStatus) (\n       KVInputStream *stream);\n Arguments Returns If an error occurred when one of the input stream function pointers was last called, this function should return the associated ..."},"115":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpGetMainFileInfo.htm",l:-1,t:"fpGetMainFileInfo()",i:0.00210935768074077,a:"This function  determines whether a file is a container file—that is, whether it contains subfiles—and should be extracted further.  Syntax int (pascal *fpGetMainFileInfo) (\n    void               *pFile, \n    KVMainFileInfo     *fileInfo);  Arguments Returns If the file information is retrieved, ..."},"116":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpGetSubFileInfo.htm",l:-1,t:"fpGetSubFileInfo()",i:0.00493631722653446,a:"This function gets  information about a subfile in a container file. Syntax int (pascal *fpGetSubFileInfo)  (\n    void                    *pFile, \n    int                      index,\n    KVSubFileInfo           *subFileInfo); Arguments Returns If the file information is retrieved, the return value ..."},"117":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpGetSubFileMetaData.htm",l:-1,t:"fpGetSubFileMetaData()",i:0.00580658278876265,a:"This function extracts  metadata from mail stores, mail messages, and non-mail items. See  Extract Mail Metadata . Syntax int (pascal *fpGetSubFileMetaData)  (\n\tvoid                      *pFile, \n\tKVGetSubFileMetaArg        metaArg, \n\tKVSubFileMetaData         *metaData); Arguments Returns If the ..."},"118":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpOpenFile.htm",l:-1,t:"fpOpenFile()",i:0.025428074372299,a:"This function opens a file to make the file accessible for subfile extraction. Syntax int (pascal *fpOpenFile) (\n    void                      *pContext,\n    KVOpenFileArg              openArg,\n    void                      **pFile); Arguments Returns If the file is opened, the return value is ..."},"119":{y:0,u:"../Content/kv_xtract_functions/_KV_XTRACT_funct_fpOpenSubFile.htm",l:-1,t:"fpOpenSubFile()",i:0.00507205969297648,a:"This function opens a subfile as a stream, which can be used directly or passed to other KeyView interfaces. Syntax int (pascal *fpOpenSubFile) (\n        void                  *pFile,\n        KVExtractSubFileArg    extractArg,\n        KVInputStream        **stream); Arguments Returns If the subfile ..."},"120":{y:0,u:"../Content/kv_xtract_structures/_KV_XTRACT_struct.htm",l:-1,t:"File Extraction API Structures",i:0.00145117078963017,a:"File Extraction API Structures This section provides information on the structures used by the File Extraction API. These structures define the input and output parameters required to extract subfiles from a container file, and are defined in kvxtract.h. "},"121":{y:0,u:"../Content/kv_xtract_structures/_KV_XTRACT_struct_KVCredential.htm",l:-1,t:"KVCredential",i:0.00272432443215668,a:"This structure contains a count of the number of  credential elements, and a pointer to the first element of the array of individual elements. The structure is initialized by calling  fpOpenFile() , and is defined in kvxtract.h. typedef struct  ..."},"122":{y:0,u:"../Content/kv_xtract_structures/_KV_XTRACT_struct_KVCredentialComponent.htm",l:-1,t:"KVCredentialComponent",i:0.0123954090960293,a:"This structure contains the value of a credential item. The structure is defined in  kvxtract.h. typedef struct  tag_KVCredentialComponent\n{\n    KVCredKeyType      keytype;\n    union\n    {\n        void           *pkey;\n        char           *skey;\n        unsigned ..."},});